!    ERG     REAL   (3,2,2,2)  The value of the parameters on a DMSP
!                              Sattellite pass.
!    LAT     REAL   (3,2,2,2)  Latitudes at which the corresponding ERG values
!                              were obtained
!                   (i,j,k,l)
!                   i  =       1) Equatorward value
!                              2) Value of maximum
!                              3) Poleward value
!                   j  =       1) Electron values
!                              2) Proton values
!                   k  =       1) Fluxes
!                              2) Mean energies
!                   l  =       1) First intersection of point by DMSP satellite
!                              2) Second intersection of point by DMSP satellite
!    MLT     REAL   (3,2,2,2)  Local times at which the corresponding ERG values
!                              were obtained
!                   (i,j,k,l)
!                   i  =       1) Equatorward value
!                              2) Value of maximum
!                              3) Poleward value
!                   j  =       1) Electron values
!                              2) Proton values
!                   k  =       1) Fluxes
!                              2) Mean energies
!                   l  =       1) First intersection of point by DMSP satellite
!                              2) Second intersection of point by DMSP satellite
!
!    LAT0    REAL   (3,2,2)    The Geomagnetic latitude corresponding
!                              to the circle center
!                   (i,j,k)
!                   i  =       1) Equatorward value
!                              2) Value of maximum
!                              3) Poleward value
!                   j  =       1) Electron values
!                              2) Proton values
!                   k  =       1) Fluxes
!                              2) Mean energies
!    MLT0    REAL   (3,2,2)    The Geomagnetic local time corresponding
!                              to the circle center
!                   (i,j,k)
!                   i  =       1) Equatorward value
!                              2) Value of maximum
!                              3) Poleward value
!                   j  =       1) Electron values
!                              2) Proton values
!                   k  =       1) Fluxes
!                              2) Mean energies
!    RAD0    REAL   (3,2,2)    The radius of the circular boundary
!                   (i,j,k)
!                   i  =       1) Equatorward value
!                              2) Value of maximum
!                              3) Poleward value
!                   j  =       1) Electron values
!                              2) Proton values
!                   k  =       1) Fluxes
!                              2) Mean energies
!
!    MLATR   REAL              Magnetic latitude of trough-midlatitude
!                              boundary
!    MLTR    REAL              Magnetic latitude of trough-midlatitude
!                              boundary
!    VALTR   REAL              Magnetic latitude of trough-midlatitude
!                              boundary
!    MLATR0  REAL              Magnetic latitude of trough-midlatitude
!                              boundary
!    MLTR0   REAL              Magnetic latitude of trough-midlatitude
!                              boundary
!    RADTR0  REAL              Magnetic latitude of trough-midlatitude
!                              boundary
!
       REAL A0,A1,B1,LAT0,MLT0,RAD0,LAT,MLT,ERG,MLATR,MLTR,VALTR, &
      MLATR0,MLTR0,RADTR0
!
      COMMON/PRECP1/LAT0(3,2,2,2),MLT0(3,2,2,2),RAD0(3,2,2,2), &
      A0(2,2,2),A1(2,2,2),B1(2,2,2),LAT(3,2,2,2,2,2),MLT(3,2,2,2,2,2), &
      ERG(3,2,2,2,2,2),MLATR(2,2,2),MLTR(2,2,2),VALTR(2,2,2),MLATR0(2), &
      MLTR0(2),RADTR0(2)
!
!
